CREATE TABLE FUNCIONARIO (
  LOGIN     VARCHAR(15)     NOT NULL,
  SENHA     VARCHAR(15)     NOT NULL,
  NOME      VARCHAR(50)     NOT NULL,
  PRIMARY KEY (LOGIN)
) TYPE = INNODB;

CREATE TABLE ASSUNTO(
  CODIGO        INT             NOT NULL     AUTO_INCREMENT,
  DESCRICAO     VARCHAR(50)     NOT NULL,
  PRIMARY KEY (CODIGO)
) TYPE = INNODB;

CREATE TABLE AUTOR (
  CODIGO     INT             NOT NULL     AUTO_INCREMENT,
  NOME       VARCHAR(50)     NOT NULL,
  PRIMARY KEY (CODIGO)
) TYPE = INNODB;

CREATE TABLE LIVRO (
  CODIGO         INT                NOT NULL     AUTO_INCREMENT,
  TITULO         VARCHAR(100)       NOT NULL,
  PRECO          NUMERIC(15,2)      NOT NULL,
  ANO            INT                NOT NULL,
  PAGINAS        INT                NOT NULL,
  ID_ASSUNTO     INT                NOT NULL,
  PRIMARY KEY (CODIGO)
) TYPE = INNODB;

CREATE TABLE LIVRO_AUTOR (
  ID_LIVRO     INT     NOT NULL,
  ID_AUTOR     INT     NOT NULL,
  PRIMARY KEY (ID_LIVRO,ID_AUTOR)
) TYPE = INNODB;

CREATE TABLE CLIENTE (
  EMAIL     VARCHAR(50)     NOT NULL,
  SENHA     VARCHAR(15)     NOT NULL,
  NOME      VARCHAR(50)     NOT NULL,
  PRIMARY KEY (EMAIL)
) TYPE = INNODB;

CREATE TABLE PEDIDO (
  NUMERO         INT             NOT NULL     AUTO_INCREMENT,
  DATA           DATE            NOT NULL,
  HORARIO        TIME            NOT NULL,
  ID_CLIENTE     VARCHAR(50)     NOT NULL,
  PRIMARY KEY (NUMERO)
) TYPE = INNODB;

CREATE TABLE ITEM (
  ID_PEDIDO      INT               NOT NULL,
  ID_LIVRO       INT               NOT NULL,
  QUANTIDADE     INT               NOT NULL,
  UNITARIO       NUMERIC(15,2)     NOT NULL,
  PRIMARY KEY (ID_PEDIDO, ID_LIVRO)
) TYPE = INNODB;

ALTER TABLE LIVRO ADD CONSTRAINT FK_LIVRO_ASSUNTO
  FOREIGN KEY (ID_ASSUNTO) REFERENCES ASSUNTO (CODIGO)
  ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE LIVRO_AUTOR ADD CONSTRAINT FK_LIVRO
  FOREIGN KEY (ID_LIVRO) REFERENCES LIVRO (CODIGO)
  ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE LIVRO_AUTOR ADD CONSTRAINT FK_AUTOR
  FOREIGN KEY (ID_AUTOR) REFERENCES AUTOR (CODIGO)
  ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE PEDIDO ADD CONSTRAINT FK_PEDIDO_CLIENTE
  FOREIGN KEY (ID_CLIENTE) REFERENCES CLIENTE (EMAIL)
  ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE ITEM ADD CONSTRAINT FK_ITEM_LIVRO
  FOREIGN KEY (ID_LIVRO) REFERENCES LIVRO (CODIGO)
  ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE ITEM ADD CONSTRAINT FK_ITEM_PEDIDO
  FOREIGN KEY (ID_PEDIDO) REFERENCES PEDIDO (NUMERO)
  ON DELETE CASCADE ON UPDATE CASCADE;
