package ruirossi.editora.beans;

import ruirossi.editora.erros.*;

public class AutorBean {
  private int codigo;
  private String nome;
  
  public AutorBean() { }
  
  public AutorBean(String codigo, String nome)
    throws EditoraException {
    setCodigo(codigo);
    setNome(nome);
  }
  
  public int getCodigo() {return codigo;}
  public String getNome() {return nome;}
  
  public void setCodigo(int codigo) throws EditoraException {
    if (codigo <= 0) 
      throw new EditoraException("O cdigo deve ser maior que zero");
    this.codigo = codigo;
  }
  
  public void setCodigo(String codigo) throws EditoraException {
    if (codigo == null)
      throw new EditoraException("O cdigo no pode ser nulo");
    try {setCodigo(Integer.parseInt(codigo));}
    catch (NumberFormatException nf) {
      throw new EditoraException("Cdigo invlido: " + codigo);
    }
  }
  
  public void setNome(String nome) throws EditoraException {
    if (nome == null)
      throw new EditoraException("O nome no pode ser nulo");
    nome = nome.trim();
    if (nome.length() == 0)
      throw new EditoraException(" preciso informar o nome");
    if (nome.length() > 50)
      throw new EditoraException("Nome com mais de 50 caracteres");
    this.nome = nome;
  }
  
  public String toString() {
    return codigo + " - " + nome;
  }
}