package ruirossi.editora.beans;

import ruirossi.editora.erros.*;
import java.util.*;

public class ItemBean {
  private int idPedido;
  private int idLivro;
  private int quantidade;
  private double unitario;
  
  public ItemBean() { }
  
  public ItemBean(String idPedido, String idLivro, String quantidade,
    String unitario) throws EditoraException {
    setIdPedido(idPedido);
    setUnitario(unitario);
    setIdLivro(idLivro);
    setQuantidade(quantidade);
  }
  
  public int getIdPedido() {return idPedido;}
  public int getIdLivro() {return idLivro;}
  public int getQuantidade() {return quantidade;}
  public double getUnitario() {return unitario;}
  
  public void setIdPedido(int idPedido) throws EditoraException {
    if (idPedido <= 0) 
      throw new EditoraException("Pedido invlido: " + idPedido);
    this.idPedido = idPedido;
  }
  
  public void setIdPedido(String idPedido) throws EditoraException {
    if (idPedido == null)
      throw new EditoraException("O pedido no pode ser nulo");
    try {setIdPedido(Integer.parseInt(idPedido));}
    catch (NumberFormatException nf) {
      throw new EditoraException("Pedido invlido: " + idPedido);
    }
  }
  
  public void setIdLivro(int idLivro) throws EditoraException {
    if (idLivro <= 0) 
      throw new EditoraException("Livro invlido: " + idLivro);
    this.idLivro = idLivro;
  }
  
  public void setIdLivro(String idLivro) throws EditoraException {
    if (idLivro == null)
      throw new EditoraException("O livro no pode ser nulo");
    try {setIdLivro(Integer.parseInt(idLivro));}
    catch (NumberFormatException nf) {
      throw new EditoraException("Livro invlido: " + idLivro);
    }
  }
  
  public void setQuantidade(int quantidade) throws EditoraException {
    if (quantidade <= 0)
      throw new EditoraException("A quantidade deve ser positiva");
    this.quantidade = quantidade;
  }
  
  public void setQuantidade(String qtde) throws EditoraException {
    if (qtde == null)
      throw new EditoraException("A quantidade no pode ser nula");
    try {setQuantidade(Integer.parseInt(qtde));}
    catch (NumberFormatException nf) {
      throw new EditoraException("Quantidade invlida: " + qtde);
    }
  }
  
  public void setUnitario(double unitario) throws EditoraException {
    if (unitario <= 0)
      throw new EditoraException("O preo deve ser positivo");
    this.unitario = unitario;
  }
  
  public void setUnitario(String unitario) throws EditoraException {
    if (unitario == null)
      throw new EditoraException("O preo no pode ser nulo");
    try {setUnitario(Double.parseDouble(unitario));}
    catch (NumberFormatException nf) {
      throw new EditoraException("Preo invlido: " + unitario);
    }
  }
}