package ruirossi.editora.persistencia;

import ruirossi.editora.erros.*;
import ruirossi.editora.beans.*;
import java.sql.*;
import java.util.Collection;
import java.util.Vector;

public class ClienteMySQL implements ClienteDAO{
  public void incluir (ClienteBean b) throws EditoraException {
    ConexaoMySQL con = new ConexaoMySQL();
    String sql = "INSERT INTO CLIENTE VALUES (?,?,?)";
    con.prepararPst(sql);
    con.setParam(1,b.getEmail());
    con.setParam(2,b.getSenha());
    con.setParam(3,b.getNome());
    con.executarPst(con.ACAO_FECHAR);
  }
  
  public void excluir (ClienteBean b) throws EditoraException {
    ConexaoMySQL con = new ConexaoMySQL();
    String sql = "DELETE FROM CLIENTE WHERE EMAIL = ?";
    con.prepararPst(sql);
    con.setParam(1,b.getEmail());
    con.executarPst(con.ACAO_FECHAR);
  }
  
  public Collection listar () throws EditoraException {
    ConexaoMySQL con = new ConexaoMySQL();
    String sql = "SELECT * FROM CLIENTE ORDER BY NOME";
    con.prepararPst(sql);
    Vector dados = con.selecionar();
    Collection resposta = new Vector();
    for (int i = 0; i < dados.size(); i++) {
      Vector li = (Vector)dados.get(i);
      resposta.add(new ClienteBean(li.get(0).toString(),
        li.get(1).toString(),li.get(2).toString()));
    }
    return resposta;
  }
  
  public ClienteBean selecionar(String email) throws EditoraException{
    ConexaoMySQL con = new ConexaoMySQL();
    String sql = "SELECT * FROM CLIENTE WHERE EMAIL LIKE ?";
    con.prepararPst(sql);
    con.setParam(1,email);
    Vector dados = con.selecionar();
    
    if (dados.size() > 0) {
      Vector li = (Vector) dados.get(0);
      return  new ClienteBean(li.get(0).toString(),
        li.get(1).toString(),li.get(2).toString());
    }
    else throw new EditoraException("Cliente no existe: " + email);
  }
  
  public ClienteBean validar(ClienteBean b) throws EditoraException{
    ConexaoMySQL con = new ConexaoMySQL();
    String sql = "SELECT * FROM CLIENTE WHERE (EMAIL = ?) " +
      "AND (SENHA = ?)";
    con.prepararPst(sql);
    con.setParam(1,b.getEmail());
    con.setParam(2,b.getSenha());
    Vector dados = con.selecionar();
    
    if (dados.size() > 0) {
      Vector li = (Vector) dados.get(0);
      return  new ClienteBean(li.get(0).toString(),
        li.get(1).toString(),li.get(2).toString());
    }
    else return null;
  }
}