package ruirossi.editora.persistencia;

import ruirossi.editora.erros.*;
import ruirossi.editora.beans.*;
import java.sql.*;
import java.util.Collection;
import java.util.Vector;

public class FuncionarioMySQL implements FuncionarioDAO{
  public void incluir (FuncionarioBean b) throws EditoraException {
    ConexaoMySQL con = new ConexaoMySQL();
    String sql = "INSERT INTO FUNCIONARIO VALUES (?,?,?)";
    con.prepararPst(sql);
    con.setParam(1,b.getLogin());
    con.setParam(2,b.getSenha());
    con.setParam(3,b.getNome());
    con.executarPst(con.ACAO_FECHAR);
  }
  
  public void excluir (FuncionarioBean b) throws EditoraException {
    ConexaoMySQL con = new ConexaoMySQL();
    String sql = "DELETE FROM FUNCIONARIO WHERE LOGIN = ?";
    con.prepararPst(sql);
    con.setParam(1,b.getLogin());
    con.executarPst(con.ACAO_FECHAR);
  }
  
  public Collection listar () throws EditoraException {
    ConexaoMySQL con = new ConexaoMySQL();
    String sql = "SELECT * FROM FUNCIONARIO ORDER BY NOME";
    con.prepararPst(sql);
    Vector dados = con.selecionar();
    Collection resposta = new Vector();
    for (int i = 0; i < dados.size(); i++) {
      Vector li = (Vector)dados.get(i);
      resposta.add(new FuncionarioBean(li.get(0).toString(),
        li.get(1).toString(),li.get(2).toString()));
    }
    return resposta;
  }
  
  public FuncionarioBean validar (FuncionarioBean b)
    throws EditoraException {
    ConexaoMySQL con = new ConexaoMySQL();
    String sql = "SELECT * FROM FUNCIONARIO WHERE (LOGIN = ?) " +
      "AND (SENHA = ?)";
    con.prepararPst(sql);
    con.setParam(1,b.getLogin());
    con.setParam(2,b.getSenha());
    Vector dados = con.selecionar();
    
    if (dados.size() > 0) {
      Vector li = (Vector) dados.get(0);
      return  new FuncionarioBean(li.get(0).toString(),
        li.get(1).toString(),li.get(2).toString());
    }
    else return null;
  }
}