package ruirossi.editora.persistencia;

import ruirossi.editora.beans.*;
import ruirossi.editora.erros.*;
import ruirossi.editora.negocio.*;
import java.sql.*;
import java.text.*;
import java.util.Collection;
import java.util.Iterator;
import java.util.Vector;

public class PedidoMySQL implements PedidoDAO {
  public void incluir (PedidoBean b) throws EditoraException {
    ConexaoMySQL con = new ConexaoMySQL();
    String sql = "INSERT INTO PEDIDO (DATA,HORARIO,ID_CLIENTE) " +
      "VALUES (?,?,?)";
    con.prepararPst(sql);
    con.setParam(1,new Date(b.getData().getTime()));
    con.setParam(2,new Time(b.getHorario().getTime()));
    con.setParam(3,b.getCliente().getEmail());
    con.executarPst(con.ACAO_EXECUTAR);
    
    sql = "SELECT  MAX(NUMERO) AS MAXIMO FROM PEDIDO";
    con.prepararPst(sql);
    Vector dados = con.selecionar();
    int numero_pedido = 0;
    if (dados.size() > 0) {
      Vector linha = (Vector)dados.get(0);
      numero_pedido = Integer.parseInt(linha.get(0).toString());
    }
    else throw new EditoraException("A operao no foi concluda");
        
    Iterator i = b.getItens().iterator();
    while (i.hasNext()) {
      ItemBean ib = (ItemBean)i.next();
    
      sql = "INSERT INTO ITEM VALUES (?,?,?,?)";
      con.prepararPst(sql);
      con.setParam(1,numero_pedido);
      con.setParam(2,ib.getIdLivro());
      con.setParam(3,ib.getQuantidade());
      con.setParam(4,ib.getUnitario());
      con.executarPst(con.ACAO_EXECUTAR);
    }
    con.confirmar();
  }
  
  public void excluir (PedidoBean b) throws EditoraException {
    ConexaoMySQL con = new ConexaoMySQL();
    String sql = "DELETE FROM ITEM WHERE ID_PEDIDO = ?";
    con.prepararPst(sql);
    con.setParam(1,b.getNumero());
    con.executarPst(con.ACAO_EXECUTAR);
    sql = "DELETE FROM PEDIDO WHERE NUMERO = ?";
    con.prepararPst(sql);
    con.setParam(1,b.getNumero());
    con.executarPst(con.ACAO_FECHAR);
  }
  
  public Collection listar () throws EditoraException {
    ConexaoMySQL con = new ConexaoMySQL();
    String sql = "SELECT * FROM PEDIDO";
    con.prepararPst(sql);
    Vector dados = con.selecionar();
    
    Collection resposta = new Vector();
    for (int i = 0; i < dados.size(); i++) {
      Vector li = (Vector)dados.get(i);
      PedidoBean b = new PedidoBean();
      b.setNumero(li.get(0).toString());
      b = selecionar(b.getNumero());
      resposta.add(b);
    }
    return resposta;
  }
  
  public PedidoBean selecionar (int numero) throws EditoraException {
    ConexaoMySQL con = new ConexaoMySQL();
    String sql = "SELECT * FROM PEDIDO WHERE NUMERO = ?";
    con.prepararPst(sql);
    con.setParam(1,numero);
    Vector dados = con.selecionar();
    
    SimpleDateFormat data = new SimpleDateFormat("yyyy-MM-dd");
    SimpleDateFormat hora = new SimpleDateFormat("HH:mm:ss");
    
    PedidoBean b = new PedidoBean();
    if (dados.size() > 0) {
      Vector li = (Vector)dados.get(0);
      b.setNumero(li.get(0).toString());
      try {b.setData(data.parse(li.get(1).toString()));}
      catch(ParseException pe) {b.setData("01/01/01");}
      try {b.setHorario(hora.parse(li.get(2).toString()));}
      catch(ParseException pe) {b.setHorario("00:00");}
      b.setCliente(ClienteBO.selecionar(li.get(3).toString()));
    }
    else throw new EditoraException("Pedido no existe: " + numero);
    
    sql = "SELECT * FROM ITEM WHERE ID_PEDIDO = ?";
    con.prepararPst(sql);
    con.setParam(1,b.getNumero());
    Vector itens = con.selecionar();
    Collection co_itens = new Vector();
    
    for (int k = 0; k < itens.size(); k++) {
      Vector item = (Vector)itens.get(k);
      co_itens.add(new ItemBean(item.get(0).toString(),
        item.get(1).toString(),item.get(2).toString(),
        item.get(3).toString()));
    }
    
    b.setItens(co_itens);
    return b;
  }
  
  public Collection selecionar (String cliente)
    throws EditoraException {
    ConexaoMySQL con = new ConexaoMySQL();
    String sql = "SELECT * FROM PEDIDO WHERE ID_CLIENTE = ?";
    con.prepararPst(sql);
    con.setParam(1,cliente);
    Vector dados = con.selecionar();
    
    Collection resposta = new Vector();
    for (int i = 0; i < dados.size(); i++) {
      Vector li = (Vector)dados.get(i);
      PedidoBean b = new PedidoBean();
      b.setNumero(li.get(0).toString());
      b = selecionar(b.getNumero());
      resposta.add(b);
    }
    return resposta;
  }
}