package ruirossi.livrojsp;

import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class ServletControlador extends HttpServlet {
  protected void doGet(HttpServletRequest req,
    HttpServletResponse res) throws ServletException, IOException {
    processar(req,res);
  }
  
  protected void doPost(HttpServletRequest req,
    HttpServletResponse res) throws ServletException, IOException {
    processar(req, res);
  }
  
  protected void processar(HttpServletRequest req,
    HttpServletResponse res) throws ServletException, IOException {
    String operacao = req.getParameter("ope");
    String url = "/index.jsp";
    
    if (operacao.equals("gravar"))
      url = gravarVisita(req);
    else if(operacao.equals("rel"))
      url = gerarRelatorio(req);
    
    ServletContext sc = getServletContext();
    RequestDispatcher rd = sc.getRequestDispatcher(url);
    rd.forward(req,res);
  }
  
  public String gravarVisita(HttpServletRequest req)
    throws ServletException, IOException {
    VisitaBean vb = new VisitaBean();
    vb.setNome(req.getParameter("nome"));
    vb.setEmail(req.getParameter("email"));
    vb.setComentarios(req.getParameter("comentarios"));
    vb.setData(new Date());
    
    try {
      if (vb.getNome().trim().length() == 0 || 
        vb.getEmail().trim().length() == 0 ||
        vb.getComentarios().trim().length() == 0)
        throw new Exception("Campo obrigatrio no informado!");
      
      VisitaDAO.incluir(vb);
    }
    catch (Exception ex) {
      req.setAttribute("erro",ex);
      return "/erro_tratado.jsp";
    }
    
    req.setAttribute("visita", vb);
    return "/sucesso.jsp";
  }
  
  public String gerarRelatorio(HttpServletRequest req)
    throws ServletException, IOException {
    try {
      Vector visitas = (Vector)VisitaDAO.gerarRelatorio();
      req.setAttribute("dados", visitas);
      return "/livro.jsp";
    }
    catch (Exception ex) {
      req.setAttribute("erro",ex);
      return "/erro_tratado.jsp";
    }
  }
}