package ruirossi.livrojsp;

import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class MeuServlet extends HttpServlet {
  protected void doGet(HttpServletRequest request, 
    HttpServletResponse response)
    throws ServletException, IOException {
    processar(request, response);
  }
  
  protected void doPost(HttpServletRequest request, 
    HttpServletResponse response)
    throws ServletException, IOException {
    processar(request, response);
  }
  
  protected void processar(HttpServletRequest request, 
    HttpServletResponse response)
    throws ServletException, IOException {
    
    String operacao = request.getParameter("ope");
    String url = "/index.jsp";
    
    if (operacao.equals("gravar"))
      url = incluirProduto(request,response);
    else if(operacao.equals("rel"))
      url = "/relatorio.jsp";
    
    ServletContext sc = getServletContext();
    RequestDispatcher rd = sc.getRequestDispatcher(url);
    rd.forward(request, response);
  }
  
  public String incluirProduto(HttpServletRequest request, 
    HttpServletResponse response)
    throws ServletException, IOException {
      int codigo = 0;
      String nome = "";
      double valor = 0.0;
      
      try {
        codigo = Integer.parseInt(request.getParameter("codigo"));
        nome = request.getParameter("nome");
        valor = Double.parseDouble(request.getParameter("valor"));
      }
      catch (NumberFormatException nfe) {
        request.setAttribute("javax.servlet.jsp.jspException", nfe);
        return "/erro.jsp";
      }
      
      Produto produto = new Produto(codigo, nome, valor);
      
      HttpSession sessao = request.getSession();
      Vector vetor = (Vector)sessao.getAttribute("dados");
      if (vetor == null) vetor = new Vector();
      
      vetor.add(produto);
      sessao.setAttribute("dados", vetor);
      sessao.setAttribute("pro", produto);
      
      return "/ok.jsp";
  }
}