package ruirossi.editora.beans;

import ruirossi.editora.erros.*;

public class AssuntoBean {
  private int codigo;
  private String descricao;
  
  public AssuntoBean() { }
  
  public AssuntoBean(String codigo, String descricao)
    throws EditoraException {
    setCodigo(codigo);
    setDescricao(descricao);
  }
  
  public int getCodigo() {return codigo;}
  public String getDescricao() {return descricao;}
  
  public void setCodigo(int codigo) throws EditoraException {
    if (codigo <= 0) 
      throw new EditoraException("O cdigo deve ser maior que zero");
    this.codigo = codigo;
  }
  
  public void setCodigo(String codigo) throws EditoraException {
    if (codigo == null)
      throw new EditoraException("O cdigo no pode ser nulo");
    try {setCodigo(Integer.parseInt(codigo));}
    catch (NumberFormatException nf) {
      throw new EditoraException("Cdigo invlido: " + codigo);
    }
  }
  
  public void setDescricao(String descricao) throws EditoraException {
    if (descricao == null) 
      throw new EditoraException("A descrio no pode ser nula");
    descricao = descricao.trim();
    if (descricao.length() == 0) 
      throw new EditoraException(" preciso informar a descrio");
    if (descricao.length() > 50) 
      throw new EditoraException("Descrio com mais de 50 letras");
    this.descricao = descricao;
  }
  
  public String toString() {
    return codigo + " - " + descricao;
  }
}