package ruirossi.editora.beans;

import ruirossi.editora.erros.*;

public class ClienteBean {
  private String email;
  private String senha;
  private String nome;
  
  public ClienteBean() { }
  
  public ClienteBean(String email, String senha, String nome) 
    throws EditoraException {
    setEmail(email);
    setSenha(senha);
    setNome(nome);
  }
  
  public String getEmail() {return email;}
  public String getSenha() {return senha;}
  public String getNome() {return nome;}
  
  public void setEmail(String email) throws EditoraException {
    if (email == null)
      throw new EditoraException("O email no pode ser nulo");
    email = email.trim();
    if (email.length() == 0)
      throw new EditoraException(" preciso informar o e-mail");
    if (email.length() > 50)
      throw new EditoraException("E-mail com mais de 50 caracteres");
    this.email = email;
  }
  
  public void setSenha(String senha) throws EditoraException {
    if (senha == null)
      throw new EditoraException("A senha no pode ser nula");
    senha = senha.trim();
    if (senha.length() == 0)
      throw new EditoraException(" preciso informar a senha");
    if (senha.length() > 15)
      throw new EditoraException("Senha com mais de 10 caracteres");
    this.senha = senha;
  }
  
  public void setNome(String nome) throws EditoraException {
    if (nome == null)
      throw new EditoraException("O nome no pode ser nulo");
    nome = nome.trim();
    if (nome.length() == 0)
      throw new EditoraException(" preciso informar o nome");
    if (nome.length() > 50)
      throw new EditoraException("Nome com mais de 50 caracteres");
    this.nome = nome;
  }
  
  public String toString() {
    return email + " - " + nome;
  }
}