package ruirossi.editora.beans;

import ruirossi.editora.erros.*;

public class FuncionarioBean {
  private String login;
  private String senha;
  private String nome;
  
  public FuncionarioBean() { }
  
  public FuncionarioBean(String login, String senha, String nome) 
    throws EditoraException {
    setLogin(login);
    setSenha(senha);
    setNome(nome);
  }
  
  public String getLogin() {return login;}
  public String getSenha() {return senha;}
  public String getNome() {return nome;}
  
  public void setLogin(String login) throws EditoraException {
    if (login == null)
      throw new EditoraException("O login no pode ser nulo");
    login = login.trim();
    if (login.length() == 0)
      throw new EditoraException(" preciso informar o login");
    if (login.length() > 15)
      throw new EditoraException("login com mais de 15 caracteres");
    this.login = login;
  }
  
  public void setSenha(String senha) throws EditoraException {
    if (senha == null)
      throw new EditoraException("A senha no pode ser nula");
    senha = senha.trim();
    if (senha.length() == 0)
      throw new EditoraException(" preciso informar a senha");
    if (senha.length() > 15)
      throw new EditoraException("Senha com mais de 10 caracteres");
    this.senha = senha;
  }
  
  public void setNome(String nome) throws EditoraException {
    if (nome == null)
      throw new EditoraException("O nome no pode ser nulo");
    nome = nome.trim();
    if (nome.length() == 0)
      throw new EditoraException(" preciso informar o nome");
    if (nome.length() > 50)
      throw new EditoraException("Nome com mais de 50 caracteres");
    this.nome = nome;
  }
  
  public String toString() {
    return login + " - " + nome;
  }
}