package ruirossi.editora.persistencia;

import ruirossi.editora.erros.*;
import ruirossi.editora.beans.*;
import java.sql.*;
import java.util.Collection;
import java.util.Vector;

public class AssuntoMySQL implements AssuntoDAO{
  public void incluir (AssuntoBean b) throws EditoraException {
    ConexaoMySQL con = new ConexaoMySQL();
    String sql = "INSERT INTO ASSUNTO (DESCRICAO) VALUES (?)";
    con.prepararPst(sql);
    con.setParam(1,b.getDescricao());
    con.executarPst(con.ACAO_FECHAR);
  }
  
  public void excluir (AssuntoBean b) throws EditoraException {
    ConexaoMySQL con = new ConexaoMySQL();
    String sql = "DELETE FROM ASSUNTO WHERE CODIGO = ?";
    con.prepararPst(sql);
    con.setParam(1,b.getCodigo());
    con.executarPst(con.ACAO_FECHAR);
  }
  
  public Collection listar () throws EditoraException {
    ConexaoMySQL con = new ConexaoMySQL();
    String sql = "SELECT * FROM ASSUNTO ORDER BY DESCRICAO";
    con.prepararPst(sql);
    Vector dados = con.selecionar();
    Collection resposta = new Vector();
    for (int i = 0; i < dados.size(); i++) {
      Vector li = (Vector)dados.get(i);
      resposta.add(new AssuntoBean(li.get(0).toString(),
        li.get(1).toString()));
    }
    return resposta;
  }
  
  public AssuntoBean selecionar (int codigo) throws EditoraException{
    ConexaoMySQL con = new ConexaoMySQL();
    String sql = "SELECT * FROM ASSUNTO WHERE CODIGO = ?";
    con.prepararPst(sql);
    con.setParam(1,codigo);
    Vector dados = con.selecionar();
    
    Vector li = (Vector)dados.get(0);
    AssuntoBean b = new AssuntoBean(li.get(0).toString(),
      li.get(1).toString());
    return b;
  }
  
  public AssuntoBean selecionar (String descricao) 
    throws EditoraException {
    ConexaoMySQL con = new ConexaoMySQL();
    String sql = "SELECT * FROM ASSUNTO WHERE DESCRICAO = ?";
    con.prepararPst(sql);
    con.setParam(1,descricao);
    Vector dados = con.selecionar();
    
    Vector li = (Vector)dados.get(0);
    AssuntoBean b = new AssuntoBean(li.get(0).toString(),
      li.get(1).toString());
    return b;
  }
}