package ruirossi.editora.persistencia;

import ruirossi.editora.erros.*;
import ruirossi.editora.beans.*;
import java.sql.*;
import java.util.Collection;
import java.util.Vector;

public class AutorMySQL implements AutorDAO{
  public void incluir (AutorBean b) throws EditoraException {
    ConexaoMySQL con = new ConexaoMySQL();
    String sql = "INSERT INTO AUTOR (NOME) VALUES (?)";
    con.prepararPst(sql);
    con.setParam(1,b.getNome());
    con.executarPst(con.ACAO_FECHAR);
  }
  
  public void excluir (AutorBean b) throws EditoraException {
    ConexaoMySQL con = new ConexaoMySQL();
    String sql = "DELETE FROM AUTOR WHERE CODIGO = ?";
    con.prepararPst(sql);
    con.setParam(1,b.getCodigo());
    con.executarPst(con.ACAO_FECHAR);
  }
  
  public Collection listar () throws EditoraException {
    ConexaoMySQL con = new ConexaoMySQL();
    String sql = "SELECT * FROM AUTOR ORDER BY NOME";
    con.prepararPst(sql);
    Vector dados = con.selecionar();
    Collection resposta = new Vector();
    for (int i = 0; i < dados.size(); i++) {
      Vector li = (Vector)dados.get(i);
      resposta.add(new AutorBean(li.get(0).toString(),
        li.get(1).toString()));
    }
    return resposta;
  }
  
  public AutorBean selecionar (int codigo) throws EditoraException{
    ConexaoMySQL con = new ConexaoMySQL();
    String sql = "SELECT * FROM AUTOR WHERE CODIGO = ?";
    con.prepararPst(sql);
    con.setParam(1,codigo);
    Vector dados = con.selecionar();
    
    if (dados.size() > 0) {
      Vector li = (Vector)dados.get(0);
      return new AutorBean(li.get(0).toString(),li.get(1).toString());
    }
    else throw new EditoraException("Autor no existe: " + codigo);
  } 
  
  public AutorBean selecionar (String nome) throws EditoraException{
    ConexaoMySQL con = new ConexaoMySQL();
    String sql = "SELECT * FROM AUTOR WHERE NOME = ?";
    con.prepararPst(sql);
    con.setParam(1,nome);
    Vector dados = con.selecionar();
    
    if (dados.size() > 0) {
      Vector li = (Vector)dados.get(0);
      return new AutorBean(li.get(0).toString(),li.get(1).toString());
    }
    else throw new EditoraException("Autor no existe: " + nome);
  }
}